<template>
  <q-page class="q-px-md q-mt-md">
    <div class="row justify-center">
      <div class="col-12" style="max-width: 800px;">
        <q-card class="q-mb-md">
          <q-card-section>
            <div class="text-h6">Group Type in {{ group.name }}</div>
          </q-card-section>
        </q-card>
      </div>
    </div>
    <div class="row justify-center">
      <div class="col-12" style="max-width: 800px;">
        <q-card class="q-mb-md">
          <q-card-section>
            <div class="row">
              <div class="col-2 text-grey-6 text-right">
                Code :
              </div>
              <div class="col q-pl-xs text-black">
                {{ group.code }}
              </div>
            </div>
            <div class="row">
              <div class="col-2 text-grey-6 text-right">
                Name :
              </div>
              <div class="col q-pl-xs text-black">
                {{ group.name }}
              </div>
            </div>
            <div class="row">
              <div class="col-2 text-grey-6 text-right">
                Image :
              </div>
              <div class="col text-right">
                <q-img style="max-height: 128px;" contain :src="group.image" />
              </div>
            </div>
          </q-card-section>
        </q-card>
      </div>
    </div>
    <div class="row justify-center">
      <div class="col-12" style="max-width: 800px;">
        <q-table
          :rows-per-page-options="[15, 25, 50]"
          :pagination.sync="pagination"
          :columns="columns"
          :loading="loading"
          :filter="filter"
          :data="data"
          separator="cell"
          row-key="id"
          @request="onRequest"
        >
          <template v-slot:top-left>
            <q-btn
              color="primary"
              label="Game Type"
              icon="add"
              @click.prevent="modal = true"
            />
          </template>
          <q-tr slot="header" slot-scope="props" :props="props">
            <td :key="col.label" v-for="col in props.cols">
              {{ col.label }}
            </td>
          </q-tr>
          <q-tr slot="body" slot-scope="props" :props="props">
            <q-td>
              {{ props.row.code }}
            </q-td>
            <q-td>
              {{ props.row.name }}
            </q-td>

            <q-td>
              <div class="q-gutter-xs">
                <q-btn
                  @click.prevent="onDelete(props.row)"
                  color="negative"
                  size="sm"
                  round
                  icon="delete"
                />
              </div>
            </q-td>
          </q-tr>
        </q-table>
      </div>
    </div>
    <q-dialog
      v-model="modal"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card style="width: 700px; max-width: 800px;">
        <q-form @submit="onProviderSubmit">
          <q-bar>
            <q-btn dense flat icon="close" v-close-popup>
              <q-tooltip>Close</q-tooltip>
            </q-btn>
          </q-bar>
          <q-card-section>
            <q-select
              filled
              v-model="$v.typeForm.type_id.$model"
              error-message="กรุณาเลือก Provider"
              :options="typeOptions"
              use-input
              hide-selected
              fill-input
              @filter="filterOptions"
              input-debounce="0"
              emit-value
              map-options
              :option-value="'id'"
              :option-label="opt => `${opt.code} - ${opt.name}`"
            >
            </q-select>
          </q-card-section>
          <q-card-actions align="right" class="bg-primary text-white">
            <q-btn push rounded color="primary" type="submit">Submit </q-btn>
            <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
          </q-card-actions>
        </q-form>
      </q-card>
    </q-dialog>
  </q-page>
</template>
<script>
import { mapState, mapGetters, mapActions } from "vuex";
import { required } from "vuelidate/lib/validators";
import { delete_provider } from "src/store/group/v2/actions";

export default {
  name: "Type",
  data() {
    return {
      group: {},
      filter: "",
      loading: false,
      pagination: {
        sortBy: "desc",
        descending: false,
        page: 1,
        rowsPerPage: 15,
        rowsNumber: 0
      },
      data: [],
      columns: [
        { label: "Code", field: "code" },
        { label: "Name", field: "name" },
        { label: "Action" }
      ],
      permissions: () => false,
      modal: false,
      types: [],
      typeOptions: [],
      typeForm: {
        type_id: undefined
      }
    };
  },
  validations: {
    typeForm: {
      type_id: {
        required
      }
    }
  },
  computed: {
    id() {
      return this.$route.params.id;
    }
  },
  async created() {
    this.permissions = await this.initPermission("group");
    await this.load();
    await this.onRequest({
      pagination: this.pagination,
      filter: undefined
    });
    await this.initGameType();
  },
  watch: {
    modal(val) {
      if (val) {
        this.typeForm = {
          type_id: undefined
        };
      }
    }
  },
  methods: {
    ...mapActions("permission", {
      initPermission: "permission"
    }),
    ...mapActions("group/v2", {
      load_group_by_id: "load",
      load_type: "load_type",
      add_type: "add_type",
      delete_type: "delete_type"
    }),
    ...mapActions("type", {
      load_type_list: "load"
    }),
    async load() {
      if (this.id) {
        try {
          const { data } = await this.load_group_by_id(this.id);
          this.group = data;
        } catch (ex) {
          this.$dialog.errorException(ex);
        }
      } else {
        this.edit = false;
      }
    },
    async onRequest(props) {
      const { page, rowsPerPage, sortBy, descending } = props.pagination;
      const filter = props.filter;
      this.loading = true;
      const {
        data: { results, page: resultPage, per_page, total }
      } = await this.load_type({
        id: this.id,
        pagination: {
          page: page,
          page_limit: rowsPerPage
        }
      });
      // clear out existing data and add new
      this.data.splice(0, this.data.length, ...results);

      // don't forget to update local pagination object
      this.pagination.page = resultPage;
      this.pagination.rowsPerPage = per_page;
      this.pagination.rowsNumber = total;
      this.pagination.sortBy = sortBy;
      this.pagination.descending = descending;
      this.loading = false;
    },
    async initGameType() {
      const { data } = await this.load_type_list();
      this.types = data;
      this.typeOptions = data;
    },
    async onProviderSubmit() {
      this.$v.typeForm.$touch();
      this.$q.loading.show();
      if (this.$v.typeForm.$invalid) {
        this.$q.loading.hide();
        return;
      }
      try {
        const { data } = await this.add_type({
          id: this.id,
          type_id: this.typeForm.type_id
        });
        await this.onRequest({
          pagination: this.pagination,
          filter: undefined
        });
        this.$q.loading.hide();
        this.modal = false;
      } catch (ex) {
        this.$dialog.errorException(ex);
        this.$q.loading.hide();
      }
    },
    async onDelete(row) {
      this.$q
        .dialog({
          title: "Alert",
          message: `คุณต้องการลบ Provider ${row.name} ออกจาก Group หรือไม่`,
          ok: {
            color: "negative",
            label: "ลบ"
          },
          cancel: {
            flat: true,
            label: "ไม่"
          }
        })
        .onOk(async () => {
          try {
            this.$q.loading.show();
            await this.delete_type({ id: this.id, type_id: row.id });
            await this.onRequest({
              pagination: this.pagination,
              filter: undefined
            });
            this.$q.loading.hide();
          } catch (ex) {
            this.$dialog.errorException(ex);
            this.$q.loading.hide();
          }
        });
    },
    filterOptions(val, update, abort) {
      update(() => {
        const needle = val.toLowerCase();
        if (needle) {
          this.typeOptions = this.types.filter(
            v => `${v.code} - ${v.name}`.toLowerCase().indexOf(needle) > -1
          );
        } else {
          this.typeOptions = this.types;
        }
      });
    }
  }
};
</script>
